diff -ruNp linux-2.6.26.1/kernel/exit.c linux-2.6.26.1-cher1/kernel/exit.c
--- linux-2.6.26.1/kernel/exit.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/exit.c	2008-08-05 13:44:37.000000000 +0400
@@ -1244,6 +1244,7 @@ static int wait_task_zombie(struct task_
 	unsigned long state;
 	int retval, status, traced;
 	pid_t pid = task_pid_vnr(p);
+        int status2;
 
 	if (unlikely(noreap)) {
 		uid_t uid = p->uid;
@@ -1338,8 +1339,13 @@ static int wait_task_zombie(struct task_
 	retval = ru ? getrusage(p, RUSAGE_BOTH, ru) : 0;
 	status = (p->signal->flags & SIGNAL_GROUP_EXIT)
 		? p->signal->group_exit_code : p->exit_code;
+        status2 = status;
+        if (SBOX_IS_MEMLIMIT_ERR(p))
+                status2 |= 0x10000;
+        if (SBOX_IS_SECURITY_ERR(p))
+                status2 |= 0x20000;
 	if (!retval && stat_addr)
-		retval = put_user(status, stat_addr);
+		retval = put_user(status2, stat_addr);
 	if (!retval && infop)
 		retval = put_user(SIGCHLD, &infop->si_signo);
 	if (!retval && infop)
@@ -1655,6 +1661,9 @@ asmlinkage long sys_waitid(int which, pi
 	enum pid_type type;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (options & ~(WNOHANG|WNOWAIT|WEXITED|WSTOPPED|WCONTINUED))
 		return -EINVAL;
 	if (!(options & (WEXITED|WSTOPPED|WCONTINUED)))
@@ -1695,6 +1704,9 @@ asmlinkage long sys_wait4(pid_t upid, in
 	enum pid_type type;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (options & ~(WNOHANG|WUNTRACED|WCONTINUED|
 			__WNOTHREAD|__WCLONE|__WALL))
 		return -EINVAL;
@@ -1732,3 +1744,9 @@ asmlinkage long sys_waitpid(pid_t pid, i
 }
 
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/fork.c linux-2.6.26.1-cher1/kernel/fork.c
--- linux-2.6.26.1/kernel/fork.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/fork.c	2008-08-05 13:44:37.000000000 +0400
@@ -795,7 +795,10 @@ static int copy_signal(unsigned long clo
 	memcpy(sig->rlim, current->signal->rlim, sizeof sig->rlim);
 	task_unlock(current->group_leader);
 
-	if (sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY) {
+	if (sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY) {
+                tsk->it_prof_expires =
+                        msecs_to_cputime(sig->rlim[RLIMIT_MCPU].rlim_cur);
+	} else if (sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY) {
 		/*
 		 * New sole thread in the process gets an expiry time
 		 * of the whole CPU time limit.
@@ -1185,6 +1188,7 @@ static struct task_struct *copy_process(
 		    !cputime_eq(current->signal->it_prof_expires,
 				cputime_zero) ||
 		    current->signal->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY ||
+		    current->signal->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY ||
 		    !list_empty(&current->signal->cpu_timers[0]) ||
 		    !list_empty(&current->signal->cpu_timers[1]) ||
 		    !list_empty(&current->signal->cpu_timers[2])) {
@@ -1324,6 +1328,11 @@ long do_fork(unsigned long clone_flags,
 	int trace = 0;
 	long nr;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/*
 	 * We hope to recycle these flags after 2.6.26
 	 */
@@ -1560,6 +1569,9 @@ asmlinkage long sys_unshare(unsigned lon
 	struct nsproxy *new_nsproxy = NULL;
 	int do_sysvsem = 0;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	check_unshare_flags(&unshare_flags);
 
 	/* Return -EINVAL for all unsupported flags */
@@ -1678,3 +1690,9 @@ int unshare_files(struct files_struct **
 	task_unlock(task);
 	return 0;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/kexec.c linux-2.6.26.1-cher1/kernel/kexec.c
--- linux-2.6.26.1/kernel/kexec.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/kexec.c	2008-08-05 13:44:37.000000000 +0400
@@ -929,6 +929,11 @@ asmlinkage long sys_kexec_load(unsigned 
 	int locked;
 	int result;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -1415,3 +1420,9 @@ static int __init crash_save_vmcoreinfo_
 }
 
 module_init(crash_save_vmcoreinfo_init)
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/module.c linux-2.6.26.1-cher1/kernel/module.c
--- linux-2.6.26.1/kernel/module.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/module.c	2008-08-05 13:44:37.000000000 +0400
@@ -692,6 +692,11 @@ sys_delete_module(const char __user *nam
 	char name[MODULE_NAME_LEN];
 	int ret, forced = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_MODULE))
 		return -EPERM;
 
@@ -2197,6 +2202,11 @@ sys_init_module(void __user *umod,
 	struct module *mod;
 	int ret = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Must have permission */
 	if (!capable(CAP_SYS_MODULE))
 		return -EPERM;
@@ -2646,3 +2656,9 @@ void module_update_markers(void)
 	mutex_unlock(&module_mutex);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/posix-cpu-timers.c linux-2.6.26.1-cher1/kernel/posix-cpu-timers.c
--- linux-2.6.26.1/kernel/posix-cpu-timers.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/posix-cpu-timers.c	2008-08-05 13:44:37.000000000 +0400
@@ -648,6 +648,12 @@ static void arm_timer(struct k_itimer *t
 				    cputime_lt(p->signal->it_prof_expires,
 					       timer->it.cpu.expires.cpu))
 					break;
+				i = p->signal->rlim[RLIMIT_MCPU].rlim_cur;
+				if (i != RLIM_INFINITY) {
+                                        if (i <= cputime_to_msecs(timer->it.cpu.expires.cpu))
+                                                break;
+                                        goto rebalance;
+                                }
 				i = p->signal->rlim[RLIMIT_CPU].rlim_cur;
 				if (i != RLIM_INFINITY &&
 				    i <= cputime_to_secs(timer->it.cpu.expires.cpu))
@@ -1062,6 +1068,7 @@ static void check_process_timers(struct 
 	 */
 	if (list_empty(&timers[CPUCLOCK_PROF]) &&
 	    cputime_eq(sig->it_prof_expires, cputime_zero) &&
+	    sig->rlim[RLIMIT_MCPU].rlim_cur == RLIM_INFINITY &&
 	    sig->rlim[RLIMIT_CPU].rlim_cur == RLIM_INFINITY &&
 	    list_empty(&timers[CPUCLOCK_VIRT]) &&
 	    cputime_eq(sig->it_virt_expires, cputime_zero) &&
@@ -1162,6 +1169,33 @@ static void check_process_timers(struct 
 			virt_expires = sig->it_virt_expires;
 		}
 	}
+	if (sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY) {
+		unsigned long psecs = cputime_to_msecs(ptime);
+		cputime_t x;
+		if (psecs >= sig->rlim[RLIMIT_MCPU].rlim_max) {
+			/*
+			 * At the hard limit, we just die.
+			 * No need to calculate anything else now.
+			 */
+			__group_send_sig_info(SIGKILL, SEND_SIG_PRIV, tsk);
+			return;
+		}
+		if (psecs >= sig->rlim[RLIMIT_MCPU].rlim_cur) {
+			/*
+			 * At the soft limit, send a SIGXCPU every second.
+			 */
+			__group_send_sig_info(SIGXCPU, SEND_SIG_PRIV, tsk);
+			if (sig->rlim[RLIMIT_MCPU].rlim_cur
+			    < sig->rlim[RLIMIT_MCPU].rlim_max) {
+				sig->rlim[RLIMIT_MCPU].rlim_cur++;
+			}
+		}
+		x = msecs_to_cputime(sig->rlim[RLIMIT_MCPU].rlim_cur);
+		if (cputime_eq(prof_expires, cputime_zero) ||
+		    cputime_lt(x, prof_expires)) {
+			prof_expires = x;
+		}
+	}
 	if (sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY) {
 		unsigned long psecs = cputime_to_secs(ptime);
 		cputime_t x;
@@ -1418,6 +1452,9 @@ void set_process_cpu_timer(struct task_s
 		 * If the RLIMIT_CPU timer will expire before the
 		 * ITIMER_PROF timer, we have nothing else to do.
 		 */
+		if (tsk->signal->rlim[RLIMIT_MCPU].rlim_cur
+		    < cputime_to_msecs(*newval))
+			return;
 		if (tsk->signal->rlim[RLIMIT_CPU].rlim_cur
 		    < cputime_to_secs(*newval))
 			return;
@@ -1656,3 +1693,9 @@ static __init int init_posix_cpu_timers(
 	return 0;
 }
 __initcall(init_posix_cpu_timers);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/posix-timers.c linux-2.6.26.1-cher1/kernel/posix-timers.c
--- linux-2.6.26.1/kernel/posix-timers.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/posix-timers.c	2008-08-05 13:44:37.000000000 +0400
@@ -470,6 +470,9 @@ sys_timer_create(const clockid_t which_c
 	sigevent_t event;
 	int it_id_set = IT_ID_NOT_SET;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -683,6 +686,9 @@ sys_timer_gettime(timer_t timer_id, stru
 	struct itimerspec cur_setting;
 	unsigned long flags;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -713,6 +719,9 @@ sys_timer_getoverrun(timer_t timer_id)
 	int overrun;
 	unsigned long flags;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -788,6 +797,9 @@ sys_timer_settime(timer_t timer_id, int 
 	unsigned long flag;
 	struct itimerspec *rtn = old_setting ? &old_spec : NULL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (!new_setting)
 		return -EINVAL;
 
@@ -839,6 +851,9 @@ sys_timer_delete(timer_t timer_id)
 	struct k_itimer *timer;
 	unsigned long flags;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 retry_delete:
 	timer = lock_timer(timer_id, &flags);
 	if (!timer)
@@ -931,6 +946,9 @@ asmlinkage long sys_clock_settime(const 
 {
 	struct timespec new_tp;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	if (copy_from_user(&new_tp, tp, sizeof (*tp)))
@@ -945,6 +963,9 @@ sys_clock_gettime(const clockid_t which_
 	struct timespec kernel_tp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	error = CLOCK_DISPATCH(which_clock, clock_get,
@@ -962,6 +983,9 @@ sys_clock_getres(const clockid_t which_c
 	struct timespec rtn_tp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -993,6 +1017,9 @@ sys_clock_nanosleep(const clockid_t whic
 {
 	struct timespec t;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -1026,3 +1053,9 @@ clock_nanosleep_restart(struct restart_b
 	return CLOCK_DISPATCH(which_clock, nsleep_restart,
 			      (restart_block));
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/printk.c linux-2.6.26.1-cher1/kernel/printk.c
--- linux-2.6.26.1/kernel/printk.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/printk.c	2008-08-05 13:44:37.000000000 +0400
@@ -432,6 +432,9 @@ out:
 
 asmlinkage long sys_syslog(int type, char __user *buf, int len)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_syslog(type, buf, len);
 }
 
@@ -1366,3 +1369,9 @@ bool printk_timed_ratelimit(unsigned lon
 }
 EXPORT_SYMBOL(printk_timed_ratelimit);
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/ptrace.c linux-2.6.26.1-cher1/kernel/ptrace.c
--- linux-2.6.26.1/kernel/ptrace.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/ptrace.c	2008-08-05 13:44:37.000000000 +0400
@@ -539,6 +539,20 @@ asmlinkage long sys_ptrace(long request,
 	struct task_struct *child;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
+        if (request == PTRACE_MEMLIMIT) {
+                current->sbox_flags |= SBOX_MEMLIMITON;
+                return 0;
+        }
+        if (request == PTRACE_NO_SYSCALLS) {
+                current->sbox_flags |= SBOX_NO_SYSCALLS;
+                return 0;
+        }
+
 	/*
 	 * This lock_kernel fixes a subtle race with suid exec
 	 */
@@ -662,6 +676,20 @@ asmlinkage long compat_sys_ptrace(compat
 	struct task_struct *child;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
+        if (request == PTRACE_MEMLIMIT) {
+                current->sbox_flags |= SBOX_MEMLIMITON;
+                return 0;
+        }
+        if (request == PTRACE_NO_SYSCALLS) {
+                current->sbox_flags |= SBOX_NO_SYSCALLS;
+                return 0;
+        }
+
 	/*
 	 * This lock_kernel fixes a subtle race with suid exec
 	 */
@@ -699,3 +727,9 @@ asmlinkage long compat_sys_ptrace(compat
 	return ret;
 }
 #endif	/* CONFIG_COMPAT && __ARCH_WANT_COMPAT_SYS_PTRACE */
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/sched.c linux-2.6.26.1-cher1/kernel/sched.c
--- linux-2.6.26.1/kernel/sched.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/sched.c	2008-08-05 13:44:37.000000000 +0400
@@ -4639,6 +4639,11 @@ asmlinkage long sys_nice(int increment)
 {
 	long nice, retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/*
 	 * Setpriority might change our priority at the same moment.
 	 * We don't have to worry. Conceptually one call occurs first
@@ -4903,6 +4908,9 @@ do_sched_setscheduler(pid_t pid, int pol
 asmlinkage long
 sys_sched_setscheduler(pid_t pid, int policy, struct sched_param __user *param)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* negative values for policy are not valid */
 	if (policy < 0)
 		return -EINVAL;
@@ -4917,6 +4925,9 @@ sys_sched_setscheduler(pid_t pid, int po
  */
 asmlinkage long sys_sched_setparam(pid_t pid, struct sched_param __user *param)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_sched_setscheduler(pid, -1, param);
 }
 
@@ -4929,6 +4940,9 @@ asmlinkage long sys_sched_getscheduler(p
 	struct task_struct *p;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (pid < 0)
 		return -EINVAL;
 
@@ -4955,6 +4969,9 @@ asmlinkage long sys_sched_getparam(pid_t
 	struct task_struct *p;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (!param || pid < 0)
 		return -EINVAL;
 
@@ -5063,6 +5080,9 @@ asmlinkage long sys_sched_setaffinity(pi
 	cpumask_t new_mask;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = get_user_cpu_mask(user_mask_ptr, len, &new_mask);
 	if (retval)
 		return retval;
@@ -5126,6 +5146,9 @@ asmlinkage long sys_sched_getaffinity(pi
 	int ret;
 	cpumask_t mask;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (len < sizeof(cpumask_t))
 		return -EINVAL;
 
@@ -8867,3 +8890,9 @@ struct cgroup_subsys cpuacct_subsys = {
 	.subsys_id = cpuacct_subsys_id,
 };
 #endif	/* CONFIG_CGROUP_CPUACCT */
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/signal.c linux-2.6.26.1-cher1/kernel/signal.c
--- linux-2.6.26.1/kernel/signal.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/signal.c	2008-08-05 13:44:37.000000000 +0400
@@ -1129,6 +1129,14 @@ static int kill_something_info(int sig, 
 {
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                if (!pid) pid = current->pid;
+                if (pid != current->pid) {
+                        SBOX_SET_SECURITY_ERR();
+                        return -EPERM;
+                }
+        }
+
 	if (pid > 0) {
 		rcu_read_lock();
 		ret = kill_pid_info(sig, info, find_vpid(pid));
@@ -1992,6 +2000,9 @@ sys_rt_sigprocmask(int how, sigset_t __u
 	int error = -EINVAL;
 	sigset_t old_set, new_set;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		goto out;
@@ -2049,6 +2060,9 @@ out:
 asmlinkage long
 sys_rt_sigpending(sigset_t __user *set, size_t sigsetsize)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_sigpending(set, sigsetsize);
 }
 
@@ -2130,6 +2144,9 @@ sys_rt_sigtimedwait(const sigset_t __use
 	siginfo_t info;
 	long timeout = 0;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
@@ -2257,6 +2274,9 @@ static int do_tkill(int tgid, int pid, i
  */
 asmlinkage long sys_tgkill(int tgid, int pid, int sig)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* This is only valid for single tasks */
 	if (pid <= 0 || tgid <= 0)
 		return -EINVAL;
@@ -2270,6 +2290,9 @@ asmlinkage long sys_tgkill(int tgid, int
 asmlinkage long
 sys_tkill(int pid, int sig)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* This is only valid for single tasks */
 	if (pid <= 0)
 		return -EINVAL;
@@ -2282,6 +2305,9 @@ sys_rt_sigqueueinfo(int pid, int sig, si
 {
 	siginfo_t info;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (copy_from_user(&info, uinfo, sizeof(siginfo_t)))
 		return -EFAULT;
 
@@ -2409,6 +2435,9 @@ out:
 asmlinkage long
 sys_sigpending(old_sigset_t __user *set)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_sigpending(set, sizeof(*set));
 }
 
@@ -2424,6 +2453,9 @@ sys_sigprocmask(int how, old_sigset_t __
 	int error;
 	old_sigset_t old_set, new_set;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (set) {
 		error = -EFAULT;
 		if (copy_from_user(&new_set, set, sizeof(*set)))
@@ -2515,6 +2547,9 @@ sys_ssetmask(int newmask)
 {
 	int old;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	spin_lock_irq(&current->sighand->siglock);
 	old = current->blocked.sig[0];
 
@@ -2552,6 +2587,9 @@ sys_signal(int sig, __sighandler_t handl
 asmlinkage long
 sys_pause(void)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	current->state = TASK_INTERRUPTIBLE;
 	schedule();
 	return -ERESTARTNOHAND;
@@ -2564,6 +2602,9 @@ asmlinkage long sys_rt_sigsuspend(sigset
 {
 	sigset_t newset;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
@@ -2594,3 +2635,9 @@ void __init signals_init(void)
 {
 	sigqueue_cachep = KMEM_CACHE(sigqueue, SLAB_PANIC);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/sys.c linux-2.6.26.1-cher1/kernel/sys.c
--- linux-2.6.26.1/kernel/sys.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/sys.c	2008-08-05 13:44:37.000000000 +0400
@@ -144,6 +144,9 @@ asmlinkage long sys_setpriority(int whic
 	int error = -EINVAL;
 	struct pid *pgrp;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		goto out;
 
@@ -208,6 +211,9 @@ asmlinkage long sys_getpriority(int whic
 	long niceval, retval = -ESRCH;
 	struct pid *pgrp;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (which > PRIO_USER || which < PRIO_PROCESS)
 		return -EINVAL;
 
@@ -371,6 +377,11 @@ asmlinkage long sys_reboot(int magic1, i
 {
 	char buffer[256];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -493,6 +504,11 @@ asmlinkage long sys_setregid(gid_t rgid,
 	int new_egid = old_egid;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = security_task_setgid(rgid, egid, (gid_t)-1, LSM_SETID_RE);
 	if (retval)
 		return retval;
@@ -539,6 +555,11 @@ asmlinkage long sys_setgid(gid_t gid)
 	int old_egid = current->egid;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = security_task_setgid(gid, (gid_t)-1, (gid_t)-1, LSM_SETID_ID);
 	if (retval)
 		return retval;
@@ -609,6 +630,11 @@ asmlinkage long sys_setreuid(uid_t ruid,
 	int old_ruid, old_euid, old_suid, new_ruid, new_euid;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = security_task_setuid(ruid, euid, (uid_t)-1, LSM_SETID_RE);
 	if (retval)
 		return retval;
@@ -672,6 +698,11 @@ asmlinkage long sys_setuid(uid_t uid)
 	int old_ruid, old_suid, new_suid;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = security_task_setuid(uid, (uid_t)-1, (uid_t)-1, LSM_SETID_ID);
 	if (retval)
 		return retval;
@@ -712,6 +743,11 @@ asmlinkage long sys_setresuid(uid_t ruid
 	int old_suid = current->suid;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = security_task_setuid(ruid, euid, suid, LSM_SETID_RES);
 	if (retval)
 		return retval;
@@ -766,6 +802,11 @@ asmlinkage long sys_setresgid(gid_t rgid
 {
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = security_task_setgid(rgid, egid, sgid, LSM_SETID_RES);
 	if (retval)
 		return retval;
@@ -821,6 +862,11 @@ asmlinkage long sys_setfsuid(uid_t uid)
 {
 	int old_fsuid;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	old_fsuid = current->fsuid;
 	if (security_task_setuid(uid, (uid_t)-1, (uid_t)-1, LSM_SETID_FS))
 		return old_fsuid;
@@ -850,6 +896,11 @@ asmlinkage long sys_setfsgid(gid_t gid)
 {
 	int old_fsgid;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	old_fsgid = current->fsgid;
 	if (security_task_setgid(gid, (gid_t)-1, (gid_t)-1, LSM_SETID_FS))
 		return old_fsgid;
@@ -925,6 +976,9 @@ asmlinkage long sys_setpgid(pid_t pid, p
 	struct pid *pgrp;
 	int err;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (!pid)
 		pid = task_pid_vnr(group_leader);
 	if (!pgid)
@@ -995,6 +1049,9 @@ asmlinkage long sys_getpgid(pid_t pid)
 	struct pid *grp;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED() && pid != current->pid)
+                return -EPERM;
+
 	rcu_read_lock();
 	if (!pid)
 		grp = task_pgrp(current);
@@ -1036,6 +1093,11 @@ asmlinkage long sys_getsid(pid_t pid)
 	if (!pid)
 		sid = task_session(current);
 	else {
+                if (SBOX_IS_RESTRICTED() && pid != current->pid) {
+                        retval = -EPERM;
+                        goto out;
+                }
+
 		retval = -ESRCH;
 		p = find_task_by_vpid(pid);
 		if (!p)
@@ -1061,6 +1123,11 @@ asmlinkage long sys_setsid(void)
 	pid_t session = pid_vnr(sid);
 	int err = -EPERM;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	write_lock_irq(&tasklist_lock);
 	/* Fail if I am already a session leader */
 	if (group_leader->signal->leader)
@@ -1298,6 +1365,11 @@ asmlinkage long sys_setgroups(int gidset
 	struct group_info *group_info;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
@@ -1361,6 +1433,11 @@ asmlinkage long sys_sethostname(char __u
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1406,6 +1483,11 @@ asmlinkage long sys_setdomainname(char _
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1463,8 +1545,12 @@ asmlinkage long sys_setrlimit(unsigned i
 {
 	struct rlimit new_rlim, *old_rlim;
 	unsigned long it_prof_secs;
+        unsigned long it_prof_msecs;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (resource >= RLIM_NLIMITS)
 		return -EINVAL;
 	if (copy_from_user(&new_rlim, rlim, sizeof(*rlim)))
@@ -1491,11 +1577,35 @@ asmlinkage long sys_setrlimit(unsigned i
 		 */
 		new_rlim.rlim_cur = 1;
 	}
+        if (resource == RLIMIT_MCPU && new_rlim.rlim_cur == 0) {
+                new_rlim.rlim_cur = 1;
+        }
 
 	task_lock(current->group_leader);
 	*old_rlim = new_rlim;
 	task_unlock(current->group_leader);
 
+        if (resource == RLIMIT_MCPU) {
+                if (new_rlim.rlim_cur == RLIM_INFINITY)
+                        goto out;
+
+                it_prof_msecs = cputime_to_msecs(current->signal->it_prof_expires);
+                if (it_prof_msecs == 0 || new_rlim.rlim_cur <= it_prof_msecs) {
+                        unsigned long rlim_cur = new_rlim.rlim_cur;
+                        cputime_t cputime;
+
+                        cputime = msecs_to_cputime(rlim_cur);
+                        read_lock(&tasklist_lock);
+                        spin_lock_irq(&current->sighand->siglock);
+                        set_process_cpu_timer(current, CPUCLOCK_PROF, &cputime,
+                                              NULL);
+                        spin_unlock_irq(&current->sighand->siglock);
+                        read_unlock(&tasklist_lock);
+                }
+
+                goto out;
+        }
+
 	if (resource != RLIMIT_CPU)
 		goto out;
 
@@ -1645,6 +1755,9 @@ asmlinkage long sys_getrusage(int who, s
 
 asmlinkage long sys_umask(int mask)
 {
+        if (SBOX_IS_RESTRICTED())
+                return current->fs->umask;
+
 	mask = xchg(&current->fs->umask, mask & S_IRWXUGO);
 	return mask;
 }
@@ -1654,6 +1767,9 @@ asmlinkage long sys_prctl(int option, un
 {
 	long error = 0;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (security_task_prctl(option, arg2, arg3, arg4, arg5, &error))
 		return error;
 
@@ -1820,3 +1936,9 @@ int orderly_poweroff(bool force)
 	return ret;
 }
 EXPORT_SYMBOL_GPL(orderly_poweroff);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/sysctl.c linux-2.6.26.1-cher1/kernel/sysctl.c
--- linux-2.6.26.1/kernel/sysctl.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/sysctl.c	2008-08-05 13:44:37.000000000 +0400
@@ -1538,6 +1538,11 @@ asmlinkage long sys_sysctl(struct __sysc
 	struct __sysctl_args tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (copy_from_user(&tmp, args, sizeof(tmp)))
 		return -EFAULT;
 
@@ -2849,3 +2854,9 @@ EXPORT_SYMBOL(sysctl_ms_jiffies);
 EXPORT_SYMBOL(sysctl_string);
 EXPORT_SYMBOL(sysctl_data);
 EXPORT_SYMBOL(unregister_sysctl_table);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/time.c linux-2.6.26.1-cher1/kernel/time.c
--- linux-2.6.26.1/kernel/time.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/time.c	2008-08-05 13:44:37.000000000 +0400
@@ -82,6 +82,11 @@ asmlinkage long sys_stime(time_t __user 
 	struct timespec tv;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (get_user(tv.tv_sec, tptr))
 		return -EFAULT;
 
@@ -189,6 +194,11 @@ asmlinkage long sys_settimeofday(struct 
 	struct timespec	new_ts;
 	struct timezone new_tz;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (tv) {
 		if (copy_from_user(&user_tv, tv, sizeof(*tv)))
 			return -EFAULT;
@@ -208,6 +218,11 @@ asmlinkage long sys_adjtimex(struct time
 	struct timex txc;		/* Local copy of parameter */
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* Copy the user data space into the kernel copy
 	 * structure. But bear in mind that the structures
 	 * may change
@@ -669,3 +684,9 @@ EXPORT_SYMBOL(get_jiffies_64);
 #endif
 
 EXPORT_SYMBOL(jiffies);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/timer.c linux-2.6.26.1-cher1/kernel/timer.c
--- linux-2.6.26.1/kernel/timer.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/timer.c	2008-08-05 13:44:37.000000000 +0400
@@ -1357,6 +1357,9 @@ asmlinkage long sys_sysinfo(struct sysin
 {
 	struct sysinfo val;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	do_sysinfo(&val);
 
 	if (copy_to_user(info, &val, sizeof(struct sysinfo)))
@@ -1533,3 +1536,9 @@ unsigned long msleep_interruptible(unsig
 }
 
 EXPORT_SYMBOL(msleep_interruptible);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/uid16.c linux-2.6.26.1-cher1/kernel/uid16.c
--- linux-2.6.26.1/kernel/uid16.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/uid16.c	2008-08-05 13:44:37.000000000 +0400
@@ -188,6 +188,11 @@ asmlinkage long sys_setgroups16(int gids
 	struct group_info *group_info;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
diff -ruNp linux-2.6.26.1/Makefile linux-2.6.26.1-cher1/Makefile
--- linux-2.6.26.1/Makefile	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/Makefile	2008-08-05 13:44:53.000000000 +0400
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 6
 SUBLEVEL = 26
-EXTRAVERSION = .1
+EXTRAVERSION = .1-cher1
 NAME = Rotary Wombat
 
 # *DOCUMENTATION*
diff -ruNp linux-2.6.26.1/mm/fadvise.c linux-2.6.26.1-cher1/mm/fadvise.c
--- linux-2.6.26.1/mm/fadvise.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/mm/fadvise.c	2008-08-05 13:44:37.000000000 +0400
@@ -35,6 +35,11 @@ asmlinkage long sys_fadvise64_64(int fd,
 	unsigned long nrpages;
 	int ret = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+                ret = -EPERM;
+                goto out;
+        }
+
 	if (!file)
 		return -EBADF;
 
@@ -135,3 +140,9 @@ asmlinkage long sys_fadvise64(int fd, lo
 }
 
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/mm/filemap.c linux-2.6.26.1-cher1/mm/filemap.c
--- linux-2.6.26.1/mm/filemap.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/mm/filemap.c	2008-08-05 13:44:37.000000000 +0400
@@ -1258,6 +1258,9 @@ asmlinkage ssize_t sys_readahead(int fd,
 	ssize_t ret;
 	struct file *file;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = -EBADF;
 	file = fget(fd);
 	if (file) {
@@ -2599,3 +2602,9 @@ int try_to_release_page(struct page *pag
 }
 
 EXPORT_SYMBOL(try_to_release_page);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
